#!/bin/bash

declare -a packages=("bitarray-0.8.1" "FAdo-1.3.4.1" "enum34-1.1.6" "pyparsing-2.2.0" "PuLP-1.6.8" "scapy-2.3.3")

echo "Killing update-notifier ..."
sudo killall -9 update-notifier

echo "Installing Ubuntu packages..."
declare -a ubuntu=("lib" "python" "gawk")
for i in "${ubuntu[@]}"; do
	sudo dpkg -i deb/$i* || ( echo "problem installing Ubuntu packages..." ; exit 1 )
done

echo "Installing Python packages..."
unzip setuptools-38.2.5.zip && cd setuptools-38.2.5 && sudo python setup.py install && cd ..

for i in "${packages[@]}"; do
   tar xzf ${i}.tar.gz && cd ${i} && sudo python setup.py install && cd ..
done

