The Netbench Framework
==========================

The Netbench Framework consists of several experimental subdirectories where each project stores its specific libraries and tests. There is a common library in common directory. In order to be able to use this library you have to source a `setup.sh` script.


Download
--------
Netbench can be downloaded at [www.fit.vutbr.cz/netbench](http://www.fit.vutbr.cz/netbench).


Installation
------------
Python 2.x is required to run Netbench. To set the environment variables, run

```
. setup.sh
```

(Make sure you include the dot-space at the beginning.)
If you wish to set environment variables for netbench into system permanently, please follow the instruction printed by the `setup.sh` script.

Some libraries may be further dependent on third party libraries. If so, such specific dependencies are described in `README` in subdirectories for each set of algorithms.

Contributions
-------------
Send your patches, new algorithms, datasets etc. to `netbench@fit.vutbr.cz`. After review, these patches will be added to the framework.


Documentation
-------------
`netbench.pdf` is a motivation document, highlighting some features of Netbench.

`design.pdf` is a design document, describing some technical details of Netbench.

The documentation generated by the Doxygen-like Sphinx tool can be found in `doc/index.html` file.


Citations
---------
Netbench was published at the ANCS 2011 conference.
Bibtex entry:

```
@article{10.1109/ANCS.2011.25,
  author    = {Viktor Pus and Jiri Tobola and Vlastimil Kosar and Jan Kastil and Jan Korenek},
  title     = {Netbench: Framework for Evaluation of Packet Processing Algorithms},
  journal   = {Symposium On Architecture For Networking And Communications Systems},
  isbn      = {978-0-7695-4521-9},
  year      = {2011},
  pages     = {95-96},
  publisher = {IEEE Computer Society},
  address   = {Los Alamitos, CA, USA},
}
```
